Index: cpp/frams/genetics/defgenoconv.cpp
===================================================================
--- cpp/frams/genetics/defgenoconv.cpp	(revision 120)
+++ cpp/frams/genetics/defgenoconv.cpp	(revision 121)
@@ -1,2 +1,6 @@
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
 #include "defgenoconv.h"
 
@@ -4,32 +8,32 @@
 
 #ifdef USE_GENCONV_F10
-#include "conv/conv_f1.h"
+#include "f1/conv_f1.h"
 #endif
 #ifdef USE_GENCONV_F20
-#include "conv/conv_f2.h"
+#include "f2/conv_f2.h"
 #endif
 #ifdef USE_GENCONV_F32
-#include "conv/conv_f3.h"
+#include "f3/conv_f3.h"
 #endif
 #ifdef USE_GENCONV_F40
-#include "conv/conv_f4.h"
+#include "f4/conv_f4.h"
 #endif
 #ifdef USE_GENCONV_F41_TEST
-#include "conv/conv_f4.h"
+#include "f4/conv_f4.h"
 #endif
 #ifdef USE_GENCONV_F50
-#include "conv/conv_f5.h"
+#include "f5/conv_f5.h"
 #endif
 #ifdef USE_GENCONV_F60
-#include "conv/geno_f6.h"
+#include "f6/geno_f6.h"
 #endif
 #ifdef USE_GENCONV_F70
-#include "conv/conv_f7.h"
+#include "f7/conv_f7.h"
 #endif
 #ifdef USE_GENCONV_F81
-#include "conv/conv_f8tof1.h"
+#include "f8/conv_f8tof1.h"
 #endif
 #ifdef USE_GENCONV_F90
-#include "conv/conv_f9.h"
+#include "f9/conv_f9.h"
 #endif
 
Index: cpp/frams/genetics/defgenoconv.h
===================================================================
--- cpp/frams/genetics/defgenoconv.h	(revision 120)
+++ cpp/frams/genetics/defgenoconv.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f1/conv_f1.cpp
===================================================================
--- cpp/frams/genetics/f1/conv_f1.cpp	(revision 120)
+++ cpp/frams/genetics/f1/conv_f1.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2013  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/f1/conv_f1.h
===================================================================
--- cpp/frams/genetics/f1/conv_f1.h	(revision 120)
+++ cpp/frams/genetics/f1/conv_f1.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
@@ -6,5 +6,5 @@
 #define _CONV_F1_H
 
-#include <frams/genetic/genoconv.h>
+#include <frams/genetics/genoconv.h>
 #include <frams/model/model.h>
 
@@ -75,7 +75,2 @@
 
 #endif
-
-
-
-
-
Index: cpp/frams/genetics/gen-config-GDK.h
===================================================================
--- cpp/frams/genetics/gen-config-GDK.h	(revision 120)
+++ cpp/frams/genetics/gen-config-GDK.h	(revision 121)
@@ -1,4 +1,6 @@
-// This file is a part of the Framsticks GDK library. See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
+
 
 /**
@@ -16,4 +18,5 @@
 //#define USE_GENCONV_F41_TEST
 //#define USE_GENCONV_F50
+#define USE_GENCONV_F90
 
 //#define USE_GENMAN_F0
Index: cpp/frams/genetics/geno.cpp
===================================================================
--- cpp/frams/genetics/geno.cpp	(revision 120)
+++ cpp/frams/genetics/geno.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/geno.h
===================================================================
--- cpp/frams/genetics/geno.h	(revision 120)
+++ cpp/frams/genetics/geno.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genoconv.cpp
===================================================================
--- cpp/frams/genetics/genoconv.cpp	(revision 120)
+++ cpp/frams/genetics/genoconv.cpp	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/genoconv.h
===================================================================
--- cpp/frams/genetics/genoconv.h	(revision 120)
+++ cpp/frams/genetics/genoconv.h	(revision 121)
@@ -1,4 +1,4 @@
-// This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
Index: cpp/frams/genetics/oper_fx.cpp
===================================================================
--- cpp/frams/genetics/oper_fx.cpp	(revision 120)
+++ cpp/frams/genetics/oper_fx.cpp	(revision 121)
@@ -1,8 +1,8 @@
-// This file is a part of the Framsticks GenoFX library.
-// Copyright (C) 2002-2011  Maciej Komosinski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
 #include <ctype.h>  //isupper()
-#include "geno_fx.h"
+#include "oper_fx.h"
 #include <common/framsg.h>
 #include <common/nonstd_math.h>
@@ -33,5 +33,5 @@
 
 
-int Geno_fx::roulette(const double *probtab,const int count)
+int GenoOperators::roulette(const double *probtab,const int count)
 {
    double sum=0;
@@ -43,5 +43,5 @@
 }
 
-bool Geno_fx::getMinMaxDef(ParamInterface *p,int i,double &mn,double &mx,double &def)
+bool GenoOperators::getMinMaxDef(ParamInterface *p,int i,double &mn,double &mx,double &def)
 {
    mn=mx=def=0;
@@ -68,5 +68,5 @@
 }
 
-int Geno_fx::selectRandomProperty(Neuro* n)
+int GenoOperators::selectRandomProperty(Neuro* n)
 {
    int neuext=n->extraProperties().getPropCount(),
@@ -78,5 +78,5 @@
 }
 
-double Geno_fx::mutateNeuProperty(double current,Neuro *n,int i)
+double GenoOperators::mutateNeuProperty(double current,Neuro *n,int i)
 {
    if (i==-1) return mutateCreepNoLimit('f',current,-10,10); //i==-1: mutating weight of neural connection
@@ -89,5 +89,5 @@
 }
 
-bool Geno_fx::mutatePropertyNaive(ParamInterface &p,int i)
+bool GenoOperators::mutatePropertyNaive(ParamInterface &p,int i)
 {
    double mn,mx,df;
@@ -102,5 +102,5 @@
 }
 
-bool Geno_fx::mutateProperty(ParamInterface &p,int i)
+bool GenoOperators::mutateProperty(ParamInterface &p,int i)
 {
    double newval;
@@ -112,5 +112,5 @@
 }
 
-bool Geno_fx::getMutatedProperty(ParamInterface &p,int i,double oldval,double &newval)
+bool GenoOperators::getMutatedProperty(ParamInterface &p,int i,double oldval,double &newval)
 {
    newval=0;
@@ -128,5 +128,5 @@
 }
 
-double Geno_fx::mutateCreepNoLimit(char type,double current,double mn,double mx)
+double GenoOperators::mutateCreepNoLimit(char type,double current,double mn,double mx)
 {
    double result=RndGen.Gauss(current,(mx-mn)/2/5); // /halfinterval, 5 times narrower
@@ -136,5 +136,5 @@
 }
 
-double Geno_fx::mutateCreep(char type,double current,double mn,double mx)
+double GenoOperators::mutateCreep(char type,double current,double mn,double mx)
 {
    double result=mutateCreepNoLimit(type,current,mn,mx); //TODO consider that when boundary is touched (reflect/absorb below), the default precision (3 digits) may change. Is it good or bad?
@@ -148,5 +148,5 @@
 }
 
-NeuroClass* Geno_fx::getRandomNeuroClass()
+NeuroClass* GenoOperators::getRandomNeuroClass()
 {
 	SListTempl<NeuroClass*> active;
@@ -156,5 +156,5 @@
 }
 
-NeuroClass* Geno_fx::parseNeuroClass(char*& s)
+NeuroClass* GenoOperators::parseNeuroClass(char*& s)
 {
    int len=strlen(s);
@@ -171,5 +171,5 @@
 }
 
-Neuro* Geno_fx::findNeuro(const Model *m,const NeuroClass *nc)
+Neuro* GenoOperators::findNeuro(const Model *m,const NeuroClass *nc)
 {
   if (!m) return NULL;
@@ -179,5 +179,5 @@
 }
 
-int Geno_fx::neuroClassProp(char*& s,NeuroClass *nc,bool also_v1_N_props)
+int GenoOperators::neuroClassProp(char*& s,NeuroClass *nc,bool also_v1_N_props)
 {
    int len=strlen(s);
@@ -213,13 +213,13 @@
 }
 
-bool Geno_fx::isWS(const char c)
+bool GenoOperators::isWS(const char c)
 {return c==' ' || c=='\n' || c=='\t' || c=='\r';}
 
-void Geno_fx::skipWS(char *&s)
-{ if (!s) FramMessage("Geno_fx","skipWS","NULL reference!",1); else
+void GenoOperators::skipWS(char *&s)
+{ if (!s) FramMessage("GenoOperators","skipWS","NULL reference!",1); else
      while (isWS(*s)) s++;
 }
 
-bool Geno_fx::areAlike(char *g1,char *g2)
+bool GenoOperators::areAlike(char *g1,char *g2)
 {
 	while (*g1 || *g2)
@@ -235,8 +235,8 @@
 }
 
-char* Geno_fx::strchrn0(const char *str,char ch)
+char* GenoOperators::strchrn0(const char *str,char ch)
 { return ch==0?NULL:strchr((char*)str,ch); }
 
-bool Geno_fx::isNeuroClassName(const char firstchar)
+bool GenoOperators::isNeuroClassName(const char firstchar)
 {
    return isupper(firstchar) || firstchar=='|' || firstchar=='@' || firstchar=='*';
Index: cpp/frams/genetics/oper_fx.h
===================================================================
--- cpp/frams/genetics/oper_fx.h	(revision 120)
+++ cpp/frams/genetics/oper_fx.h	(revision 121)
@@ -1,8 +1,8 @@
-// This file is a part of the Framsticks GenoFX library.
-// Copyright (C) 2002-2011  Maciej Komosinski.  See LICENSE.txt for details.
+// This file is a part of the Framsticks GDK.
+// Copyright (C) 2002-2014  Maciej Komosinski and Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
-#ifndef _GENO_FX_H_
-#define _GENO_FX_H_
+#ifndef _GENO_OPERATORS_H_
+#define _GENO_OPERATORS_H_
 
 #include <common/nonstd.h>
@@ -49,5 +49,5 @@
 
 When designing genetic operations on some representation, inherit your class
-(for example Geno_fMy) from Geno_fx. Define some methods,
+(for example GenoOper_fMy) from GenoOperators. Define some methods,
 like mutate(), in your class, to allow for evolution.
 Ensure they have the same names and arguments as the corresponding
@@ -77,5 +77,5 @@
 the available source on developmental encoding and f4 genotype format.*/
 
-class Geno_fx
+class GenoOperators
 {
  public:
@@ -84,5 +84,5 @@
    SString name; ///<name of this set of genetic operators
    char **mutation_method_names; ///<array of names for mutation methods. If initialized (by new char*[]), must have entries for each method index returned by mutate(geno,chg,METHOD).  If initialized, it is automatically freed by this destructor.
-   Geno_fx() : par(empty_paramtab) {supported_format='x'; name="Default"; mutation_method_names=NULL; setDefaults();}
+   GenoOperators() : par(empty_paramtab) {supported_format='x'; name="Default"; mutation_method_names=NULL; setDefaults();}
 
 /**Used to perform initializations of Param parameters that are not handled by the Param itself
@@ -172,5 +172,5 @@
 ///currently not used (similarity of two genotypes)
    virtual float similarity(const char*,const char*) {return GENOPER_NOOPER;}
-   virtual ~Geno_fx() {if (mutation_method_names) {delete []mutation_method_names; mutation_method_names=NULL;}}
+   virtual ~GenoOperators() {if (mutation_method_names) {delete []mutation_method_names; mutation_method_names=NULL;}}
 //   virtual char getFormat() {return 255;} //returns supported genotype format, for ex. '1'
 //   virtual int enabled() {return 1;} // should be enabled by default
@@ -178,5 +178,5 @@
 /** \name Some helpful methods for you */
 //@{
-	 static int roulette(const double *probtab,const int count); 	///<returns random index according to probabilities in the \e probtab table or -1 if all probs are zero. \e count is the number of elements in \e probtab.
+   static int roulette(const double *probtab,const int count); 	///<returns random index according to probabilities in the \e probtab table or -1 if all probs are zero. \e count is the number of elements in \e probtab.
    static bool getMinMaxDef(ParamInterface *p,int propindex,double &mn,double &mx,double &def); ///<perhaps a more useful (higher-level) way to obtain min/max/def info for integer and double properties. Returns true if min/max/def was really available (otherwise it is just invented).
    static int selectRandomProperty(Neuro* n); ///<selects random property (either 0-based extraproperty of Neuro or 100-based property of its NeuroClass). -1 if Neuro has no properties.
@@ -194,5 +194,5 @@
    static void skipWS(char *&s); ///<advances pointer \e s skipping whitespaces.
    static bool areAlike(char*,char*); ///<compares two text strings skipping whitespaces. Returns 1 when equal, 0 when different.
- 	 static char* strchrn0(const char *str,char ch); ///<like strchr, but does not find zero char in \e str.
+   static char* strchrn0(const char *str,char ch); ///<like strchr, but does not find zero char in \e str.
    static bool isNeuroClassName(const char firstchar); ///<determines if \e firstchar may start NeuroClass name. If not, it may start NeuroClass' (or Neuro's) property name.
 //@}
@@ -216,3 +216,2 @@
 
 #endif
-